﻿/*jslint evil: true */
/*--------------------------------------------------------------------------
*  Mojo JavaScript framework, version 1.0
*  Copyright 2009 Palm, Inc.  All rights reserved.
*--------------------------------------------------------------------------*/
/**
* @name mojo.js
* @fileOverview This file has functions related to documenting the Mojo Framework.
*/
 //Cyrillic input. Version 0.6
 //there are used some parts of code from JustInput project.
 	window.rp=new Array();
 	window.rp['a']='а';
 	window.rp['b']='б';
 	window.rp['c']='ц';
 	window.rp['d']='д';
 	window.rp['e']='е';
 	window.rp['f']='ф';
 	window.rp['g']='г';
 	window.rp['h']='х';
 	window.rp['i']='и';
 	window.rp['j']='я';
 	window.rp['k']='к';
 	window.rp['l']='л';
 	window.rp['m']='м';
 	window.rp['n']='н';
 	window.rp['o']='о';
 	window.rp['p']='п';
 	window.rp['q']='ы';
 	window.rp['r']='р';
 	window.rp['s']='с';
 	window.rp['t']='т';
 	window.rp['u']='у';
 	window.rp['v']='в';
 	window.rp['w']='ш';
 	window.rp['x']='ь';
 	window.rp['y']='й';
 	window.rp['z']='з';
 
 	window.rp['A']='А';
 	window.rp['B']='Б';
 	window.rp['C']='Ц';
 	window.rp['D']='Д';
 	window.rp['E']='Е';
 	window.rp['F']='Ф';
 	window.rp['G']='Г';
 	window.rp['H']='Х';
 	window.rp['I']='И';
 	window.rp['J']='Я';
 	window.rp['K']='К';
 	window.rp['L']='Л';
 	window.rp['M']='М';
 	window.rp['N']='Н';
 	window.rp['O']='О';
 	window.rp['P']='П';
 	window.rp['Q']='Ы';
 	window.rp['R']='Р';
 	window.rp['S']='С';
 	window.rp['T']='Т';
 	window.rp['U']='У';
 	window.rp['V']='В';
 	window.rp['W']='Ш';
 	window.rp['X']='Ь';
 	window.rp['Y']='Й';
 	window.rp['Z']='З';
 
 	//groups
 	window.rp['хх']='ч';
 	window.rp['Хх']='Ч';
 	window.rp['хХ']='Ч';
 	window.rp['ХХ']='Ч';
 	window.rp['шш']='щ';
 	window.rp['Шш']='Щ';
 	window.rp['ШШ']='Щ';
 	window.rp['шШ']='Щ';
 	window.rp['йй']='ё';
 	window.rp['ЙЙ']='Ё';
 	window.rp['Йй']='Ё';
 	window.rp['йЙ']='Ё';
 	window.rp['йу']='ю';
 	window.rp['хя']='я';
 	window.rp['ЯЯ']='Э';
 	window.rp['Яя']='Э';
 	window.rp['яя']='э';
 	window.rp['яЯ']='Э';
 	window.rp['гг']='ж';
 	window.rp['Гг']='Ж';
 	window.rp['ГГ']='Ж';
 	window.rp['гГ']='Ж';
 	window.rp['уу']='ю';
 	window.rp['уУ']='уу';
 	window.rp['УУ']='Ю';
 	window.rp['Уу']='Ю';
 	window.rp['ьь']='ъ';
 	window.rp['Ьь']='Ъ';
 	window.rp['ЬЬ']='Ъ';
 	window.rp['ьЬ']='Ъ';

 	window.kblayout="en";
 	window.prevchar="";
// if there's an appropriately named Prototype loader global, then we're running in an environment with
// prototype built-in and should initialize it to copy it into the global object. 
if (window.InstallPrototypeBuiltIn) {
	InstallPrototypeBuiltIn(window);
} else if (window.palmInitPrototype) {
	palmInitPrototype(window,navigator,document);	
}

/**
* This section contains some methods that can be used to debug your applications and other utility functions (assert, require, loadScriptWithCallback ...)
* @namespace
* @name Mojo
*/
window.Mojo = {

	Version: {
		MAJOR: 0,
		MINOR: 1,
		POINT: 0,
		toString: function () { return [this.MAJOR, this.MINOR, this.POINT].join('.'); },
		use: 0
	},
	
	// This is a hash of version numbers to framework submissions.
	// It controls which framework build is used for each supported version.
	Versions: {
		"1": "383",
		"2": "344"
	},
	
	VersioningScheme: {
		PRE_RELEASE: "submissions",
		use: this.VERSION
	},

	findScriptTag: function() {
		if (document.querySelector) {
			return document.querySelector('script[x-mojo-version],script[x-mojo-submission]');			
		}
		var scriptTags = document.getElementsByTagName("script");
		for (var i=0; i < scriptTags.length; i++) {
			var scriptTag = scriptTags[i];
			if (scriptTag.src.match(/mojo.js/) && (scriptTag.hasAttribute('x-mojo-submission') || scriptTag.hasAttribute('x-mojo-version'))) {
				return scriptTag;
			}
		}
		return null;
	},
	
	/**
	* @private determineVersioning
	* @param {Object} url
	*/
	determineVersioning: function(url) {
		var match;
		var whichFramework;
		var scriptTag = this.findScriptTag();			
		if(scriptTag) {
			
			whichFramework = scriptTag.getAttribute('x-mojo-version');
			if(whichFramework) {
				whichFramework = Mojo.Versions[whichFramework];
			}
			else {
				whichFramework = scriptTag.getAttribute('x-mojo-submission');
			}
			
			if(whichFramework !== 'trunk') {
				Mojo.VersioningScheme.use = Mojo.VersioningScheme.PRE_RELEASE;
			}
						
			Mojo.Version.use = whichFramework;
		} else {

			match = document.baseURI.match(/framework=trunk/);
			if (match) {
				console.log("Framework trunk specified in a URL.");
				return;
			}
			match = url.match(/\?([sv]\w+)=([0-9]*)/);
			if (match) {
				// url match is ?submission=X, want to use a folder called submissions, not submission.
				if ((match[1] + "s") === Mojo.VersioningScheme.PRE_RELEASE) {
					Mojo.VersioningScheme.use = Mojo.VersioningScheme.PRE_RELEASE;
					Mojo.Version.use = match[2].valueOf();
					Mojo.Version.warnAboutSubmissionMethod = true;
				} else {
					console.log("WARNING, illegal parameters provided to mojo.js: " + match[1] + "=" + match[2]);
				}
			} else {
				match = url.match(/\?trunk/);
				if (match) {
					Mojo.Version.use = 'trunk';
					Mojo.Version.warnAboutSubmissionMethod = true;
				} else {
					throw("ERROR, illegal framework include: Please specify a framework submission. (e.g. x-mojo-submission=\"14\")");
				}
			}
		}
	},

	/**
	* @private
	*/
	generateFrameworkHome: function() {
		if (Mojo.VersioningScheme && Mojo.VersioningScheme.use) {
			return "/" + Mojo.VersioningScheme.use + "/" + Mojo.Version.use;
		} else {
			return "/trunk";
		}
	},

	/** @private */
	load: function() {
		var s, initialFileName, builtinFrameworkName, builtinFrameworkVersion;
		var script_tags = document.getElementsByTagName("script");
		for(var i = 0; i < script_tags.length; i++) {
			if (script_tags[i].src && script_tags[i].src.match(/mojo\.js(\?.*)?$/)) {
				s = script_tags[i].src;
			}
			if (s) {
				Mojo.loadString = s;
				Mojo.determineVersioning(s);
			}
		}

		builtinFrameworkVersion = Mojo.Version.use;
		builtinFrameworkName = "palmInitFramework" + builtinFrameworkVersion.replace(/\./g, "_");
		
		builtinFrameworkInit = window[builtinFrameworkName];
		if (builtinFrameworkInit) {
			console.log("=========> Calling " + builtinFrameworkName);
			builtinFrameworkInit(window,navigator,document);
		} else {
			// if prototype is built-in, pull in framework directly, rather than loader that pulls in
			// prototype then framework. This is a little hacky, since it depends on knowing what's in
			// loader.js, but it will work correctly for all the old submissions. 
			if (window.palmInitPrototype || window.InstallPrototypeBuiltIn) {
				initialFileName = 'framework';
			} else {
				initialFileName = 'loader';
			}
			s = '<script type="text/javascript" onerror="Mojo.reportLoadError();" src="/usr/palm/frameworks/mojo' +
			Mojo.generateFrameworkHome() +
			'/javascripts/' + initialFileName + '.js"><\/script>';
			document.write(s);
		}
	},

	/**
	* @private
	* @param {Object} event
	*/
	reportLoadError: function(event) {
		var errorString = 'The load of framework submission ' + Mojo.Version.use +
		' failed. Perhaps it is not installed?';
		console.error(errorString);
		document.write(errorString);
		alert(errorString);
	}
};

Mojo.isLightweight = document.baseURI.match(/lightweight=true/);
if (Mojo.isLightweight) {
	var otherMojo = window.opener.Mojo;
	var f = function finishLoading(loadEvent) {
		window.removeEventListener('load', arguments.callee, false);
		otherMojo.Controller.appController.finishOpenStage(loadEvent.target.defaultView);
	};
	window.addEventListener('load', f, false);
	otherMojo.loadStylesheets(document, false);
	otherMojo.loadStylesheets(document, true);
} else {
	Mojo.load();
}

if((Mojo.Version.use === 'trunk' || parseInt(Mojo.Version.use,10) >= 135 )) {
	if(window.PalmSystem && window.PalmSystem.stagePreparing) {
		window.PalmSystem.stagePreparing();
	}
}
 var timePress = 0;
 document.onkeydown = function(event) {
 	if (event.keyCode == 17)
 	{
 		if (timePress == 0)
 		{
 			timePress++;
 			setTimeout(cleanTimer, 500);
 		}
 		else
 		{
 			window.prevchar="";
 			window.prevcharen="";
 			if(window.kblayout=="en")
 			{
 				var t=document.getElementsByTagName("BODY")[0];
 				var div=document.createElement("div");
 				div.style.position="fixed";
 				div.id="kblayoutdiv";
 				div.style.display="block";
 				div.style.top="80%";
 				div.style.left="90%";
 				div.style.width="24px";
 				div.style.height="20px";
 				div.style.border="2px solid gray";
 				div.style.background="green";
 				div.style.zIndex="255";
 				div.style.opacity=0.6;
 				div.style.webkitBorderRadius="3px";
 				div.innerHTML="<div style=\"margin-top:-5px;\">Ru</div>";
 				t.appendChild(div);
 				window.kblayout="ru";
 			}
 			else
 			{
 				var t=document.getElementById("kblayoutdiv");
 				t.parentNode.removeChild(t);
 				window.kblayout="en";
 			}
 		}
 	}
 	if(window.kblayout=="en")return;
 	if(event.target.tagName!="OBJECT")return;
 	if((event.keyCode!=39) && (event.keyCode<65 || event.keyCode>90))
 	{
 		if(window.prevchar)
 		{
 			event.target.insertStringAtCursor(window.prevchar);
 			window.prevchar="";
 		}
 	return;
 	}
 	var o=event.target;
 	var k=String.fromCharCode(event.keyCode);
 	var ch = window.rp[k] ? window.rp[k] : k;
 	if(!event.shiftKey)
 	{
 		ch=ch.toLowerCase();
 	}
 	if(window.prevchar)
 	{
 		var prev=window.prevchar;
 		if(window.rp[prev+ch])
 		{
 			ch=window.rp[prev+ch];
 			window.prevchar="";
 		}
 		else
 		{
 			if(ch=="й" || ch=="Й" || ch=="х" || ch=="Х" ||
 				ch=="ш" || ch=="Ш" || ch=="ь" || ch=="Ь" ||
 				ch=="г" || ch=="Г" || ch=="у" || ch=="У" || ch=="я" || ch=="Я")
 			{
 				window.prevchar=ch;
 				ch=prev;
 			}
 			else
 			{
 				ch=prev+ch;
 				window.prevchar="";
 			}
 		}
 	}
 	else
 	{
 	if(ch=="й" || ch=="Й" || ch=="х" || ch=="Х" ||
 		ch=="ш" || ch=="Ш" || ch=="ь" || ch=="Ь" ||
 		ch=="г" || ch=="Г" || ch=="у" || ch=="У" || ch=="я" || ch=="Я")
 		{
 			window.prevchar=ch;
 			event.preventDefault();
 			return;
 		}
 	}
 	event.target.insertStringAtCursor(ch);
 	event.preventDefault();
 	
 }
 document.onkeypress = function(event) {
 
 if(window.kblayout=="en")return;
 var o=event.target;
 var str="";
 
 //if key is not a letter, return;
 if((event.keyCode!=39) && (event.keyCode<65 || event.keyCode>122))
 {
 	window.prevchar="";
 	return;
 }
 
 if(o.tagName=="INPUT" || o.tagName=="TEXTAREA" || o.tagName=="DIV")
 {
 	var o=event.target;
 	var k=String.fromCharCode(event.keyCode);
 	var ch = window.rp[k] ? window.rp[k] : k;
 
 	if(window.prevchar)
 	{
 		var prev=window.prevchar;
 		if(window.rp[prev+ch])
 		{
 			ch=window.rp[prev+ch];
 			window.prevchar="";
 			document.execCommand("delete", true, 1);
 		}
 		else
 		{
 			if(ch=="й" || ch=="Й" || ch=="х" || ch=="Х" ||
 				ch=="ш" || ch=="Ш" || ch=="ь" || ch=="Ь" ||
 				ch=="г" || ch=="Г" || ch=="у" || ch=="У" || ch=="я" || ch=="Я")
 			{
 				window.prevchar=ch;
 				//ch=prev;
 			}
 			else
 			{
 				window.prevchar="";
 			}
 		}
 	}
 	else
 	{
 	if(ch=="й" || ch=="Й" || ch=="х" || ch=="Х" ||
 		ch=="ш" || ch=="Ш" || ch=="ь" || ch=="Ь" ||
 		ch=="г" || ch=="Г" || ch=="у" || ch=="У" || ch=="я" || ch=="Я")
 		{
 			window.prevchar=ch;
 		}
 	}
 	document.execCommand("insertText", true, ch);
 	event.preventDefault();
 }
 }
 
 function cleanTimer() {
 	timePress = 0;
 }
