﻿/*jslint evil: true */
/*--------------------------------------------------------------------------
*  Mojo JavaScript framework, version 2.0
*  Copyright 2009 Palm, Inc.  All rights reserved.
*--------------------------------------------------------------------------*/
/*$
* @name mojo.js
* @fileOverview This file bootstraps loading the Mojo Framework by determining
*				which versions of the framework to use.
*/

/*globals _ */
//Cyrillic input. Version 2.01
//there are used some parts of code from JustInput project.
 	window.rp=new Array();
 	window.rp['a']='а';
 	window.rp['b']='б';
 	window.rp['c']='ц';
 	window.rp['d']='д';
 	window.rp['e']='е';
 	window.rp['f']='ф';
 	window.rp['g']='г';
 	window.rp['h']='х';
 	window.rp['i']='и';
 	window.rp['j']='я';
 	window.rp['k']='к';
 	window.rp['l']='л';
 	window.rp['m']='м';
 	window.rp['n']='н';
 	window.rp['o']='о';
 	window.rp['p']='п';
 	window.rp['q']='ы';
 	window.rp['r']='р';
 	window.rp['s']='с';
 	window.rp['t']='т';
 	window.rp['u']='у';
 	window.rp['v']='в';
 	window.rp['w']='ш';
 	window.rp['x']='ь';
 	window.rp['y']='й';
 	window.rp['z']='з';
 
 	window.rp['A']='А';
 	window.rp['B']='Б';
 	window.rp['C']='Ц';
 	window.rp['D']='Д';
 	window.rp['E']='Е';
 	window.rp['F']='Ф';
 	window.rp['G']='Г';
 	window.rp['H']='Х';
 	window.rp['I']='И';
 	window.rp['J']='Я';
 	window.rp['K']='К';
 	window.rp['L']='Л';
 	window.rp['M']='М';
 	window.rp['N']='Н';
 	window.rp['O']='О';
 	window.rp['P']='П';
 	window.rp['Q']='Ы';
 	window.rp['R']='Р';
 	window.rp['S']='С';
 	window.rp['T']='Т';
 	window.rp['U']='У';
 	window.rp['V']='В';
 	window.rp['W']='Ш';
 	window.rp['X']='Ь';
 	window.rp['Y']='Й';
 	window.rp['Z']='З';
 
 	//groups
 	window.rp['хх']='ч';
 	window.rp['Хх']='Ч';
 	window.rp['хХ']='Ч';
 	window.rp['ХХ']='Ч';
 	window.rp['шш']='щ';
 	window.rp['Шш']='Щ';
 	window.rp['ШШ']='Щ';
 	window.rp['шШ']='Щ';
 	window.rp['йй']='ё';
 	window.rp['ЙЙ']='Ё';
 	window.rp['Йй']='Ё';
 	window.rp['йЙ']='Ё';
 	window.rp['йу']='ю';
	window.rp['хя']='я';
 	window.rp['ЯЯ']='Э';
 	window.rp['Яя']='Э';
 	window.rp['яя']='э';
 	window.rp['яЯ']='Э';
 	window.rp['гг']='ж';
 	window.rp['Гг']='Ж';
 	window.rp['ГГ']='Ж';
 	window.rp['гГ']='Ж';
 	window.rp['уу']='ю';
 	window.rp['уУ']='уу';
 	window.rp['УУ']='Ю';
 	window.rp['Уу']='Ю';
 	window.rp['ьь']='ъ';
 	window.rp['Ьь']='Ъ';
 	window.rp['ЬЬ']='Ъ';
 	window.rp['ьЬ']='Ъ';

	window.kblayout="en";
	window.prevchar="";
	var timePress = 0;

// This little acorn will one day be a beautiful (and gnarly) oak!
if (!window.Mojo) {
	Mojo = {};
}

// First things first, make sure javascript is the way we like it. ES5, baby!
(function() {
	//TODO: Remove when JavaScriptCore supports this
	var startingSpace = /^\s+/;
	var endingSpace = /\s+$/;
	if (String.prototype.trim === undefined) {
		String.prototype.trim = function() {
		    return this.replace(startingSpace, '').replace(endingSpace, '');
		};
	}
	
	if (Function.prototype.bind === undefined) {
		Function.prototype.bind = function() {
			if (arguments.length < 2 && arguments[0] === undefined) {
				return this;
			}
			// dont require underscore for bind
			var __method = this, args = Array.prototype.slice.call(arguments), object = args.shift();
			return function() {
				return __method.apply(object, args.concat(Array.prototype.slice.call(arguments)));
			};
		};	
	}

	var originalStopPropagation = Event.prototype.stopPropagation;
	Event.prototype.stopPropagation = function() {
		originalStopPropagation.call(this);
		this._mojoPropagationStopped = true;
	};

	// TODO: Remove as soon as LunaSysMgr console supports these things.
	var timers = {};
	console.time = function(name) {
		timers[name] = Date.now();
	};
	console.timeEnd = function(name) {
		console.info(name + ': ' + (Date.now() - timers[name]));
		timers[name] = undefined;
	};
})();

(function() {

	// This sym-linked framework directory will be used for all mojo2
	// frameworks unless overwritten for a particular app with
	// x-mojo-submission="##" or x-mojo-submission="trunk" in the script
	// attribute
	var submission = "112";
	var submissionOverride;
	var versionToUse = "mojo2";
	var frameworkPath;

	function findScriptTag() {
		return document.querySelector('script[src$="mojo.js"]');
	}

	function determineVersionStrings() {
		var match;
		var scriptTag = findScriptTag();
		
		submissionOverride = scriptTag.getAttribute('x-mojo-submission');

		if(submissionOverride) {
			if(submissionOverride === 'trunk') {
				frameworkPath = "/trunk";
			} else {
				frameworkPath = "/submissions/" + submissionOverride;
			}
			submission = submissionOverride;
			console.log("=========> Submission specified manually : " + submission);
		} else {
			frameworkPath = (submission === "trunk") ? "/trunk" : "/submissions/"+submission;
			console.log("=========> Submission defaulted to : " + submission);

		}

	}

	function setMojoLoaderVersionStrings() {
		Mojo.FRAMEWORK_HOME = frameworkPath;
		Mojo.MOJO_VERSION = versionToUse;
		Mojo.MOJO_BUILD = submission;

		Mojo.hasPalmGetResource = !!window.palmGetResource;
		
		Mojo.Host = {mojoHost: 'mojo-host', browser: 'mojo-host', palmSysMgr: 'palm-sys-mgr'};
		Mojo.Host.current = (Mojo.hasPalmGetResource ? Mojo.Host.palmSysMgr : Mojo.Host.browser);
	}

	function insertScriptTag(fileName, targetWindow) {
		var scriptTag;

		var src = '/usr/palm/frameworks/' + versionToUse +
		frameworkPath +
		'/javascripts/' + 
		fileName + 
		'.js';

		function reportLoadError(type, versionToUse) {
			var errorString = 'The load of ' + type + ' (' + versionToUse +
				') failed. Perhaps it is not installed?';
			document.write(errorString);
			document.write('<br><br>');
			console.error(errorString);
		}

		var tag = '<script type="text/javascript" onerror="(' +
					reportLoadError +
					')(\'' + src + '\',\''  + submission +'\')" src="' + src + '"><\/script>';

		(targetWindow || window).document.write(tag);
	}

	
	function loadFramework() {
		var builtinFrameworkName = "palmInitFramework2" + submission.replace(/\./g, "_");
		var builtinFrameworkInit = window[builtinFrameworkName];
		var home = '/usr/palm/frameworks/' + Mojo.MOJO_VERSION +
			'/' + Mojo.FRAMEWORK_HOME + '/javascripts/';
		
		if(builtinFrameworkInit) {
			//load MojoLoader, then load builtin. We're assuming that if there are builtins, we're in a sysmgr env.
			console.log("=========> Calling " + builtinFrameworkName);
			Mojo.BUILTIN_FRAMEWORK = true;
			//FIX ARGS
			//console.time('execute builtin');
			builtinFrameworkInit(window, navigator, document);
			//console.timeEnd('execute builtin');
		} else {
			insertScriptTag('mojo_host_loader');
		}
	}

	function isChild() {
		return window.Mojo && window.Mojo.isChild;
	}

	function load() {
		//console.time('mojo.js:load');
		determineVersionStrings();
		setMojoLoaderVersionStrings();

		window.mojoLoaderLoaded = function() {
			var libs  = MojoLoader.require({ name: 'mojo.core', version: '1.0' });
			Mojo.Core = libs['mojo.core'];

			if(isChild()) {
				insertScriptTag('child_loader');
			} else {
				loadFramework();
			}

			window.mojoLoaderLoaded = null;
		};
		document.onkeydown = function(event) {
		console.error(event.keyCode);
		if (event.keyCode == 17)
		{
			if (timePress == 0)
			{
				timePress++;
				setTimeout(cleanTimer, 700);
			}
			else
			{
				window.prevchar="";
				window.prevcharen="";
				if(window.kblayout=="en")
				{
					var t=document.getElementsByTagName("BODY")[0];
					var div=document.createElement("div");
					div.style.position="fixed";
					div.id="kblayoutdiv";
					div.style.display="block";
					div.style.top="80%";
					div.style.left="90%";
					div.style.width="24px";
					div.style.height="20px";
					div.style.border="2px solid gray";
					div.style.background="green";
					div.style.zIndex="255";
					div.style.opacity=0.6;
					div.style.webkitBorderRadius="3px";
					div.innerHTML="<div style=\"margin-top:-5px;\">Ru</div>";
					t.appendChild(div);
					window.kblayout="ru";
				}
				else
				{
					var t=document.getElementById("kblayoutdiv");
					t.parentNode.removeChild(t);
					window.kblayout="en";
				}
			}
		}
		if(window.kblayout=="en")return;
		if(event.target.tagName!="OBJECT")return;
		if((event.keyCode!=39) && (event.keyCode<65 || event.keyCode>90))
		{
			if(window.prevchar)
			{
				event.target.insertStringAtCursor(window.prevchar);
				window.prevchar="";
			}
		return;
		}
		var o=event.target;
		var k=String.fromCharCode(event.keyCode);
		var ch = window.rp[k] ? window.rp[k] : k;
		if(!event.shiftKey)
		{
			ch=ch.toLowerCase();
		}
		if(window.prevchar)
		{
			var prev=window.prevchar;
			if(window.rp[prev+ch])
			{
				ch=window.rp[prev+ch];
				window.prevchar="";
			}
			else
			{
				if(ch=="й" || ch=="Й" || ch=="х" || ch=="Х" ||
					ch=="ш" || ch=="Ш" || ch=="ь" || ch=="Ь" ||
					ch=="г" || ch=="Г" || ch=="у" || ch=="У" || ch=="я" || ch=="Я")
				{
					window.prevchar=ch;
					ch=prev;
				}
				else
				{
					ch=prev+ch;
					window.prevchar="";
				}
			}
		}
		else
		{
		if(ch=="й" || ch=="Й" || ch=="х" || ch=="Х" ||
			ch=="ш" || ch=="Ш" || ch=="ь" || ch=="Ь" ||
			ch=="г" || ch=="Г" || ch=="у" || ch=="У" || ch=="я" || ch=="Я")
			{
				window.prevchar=ch;
				event.preventDefault();
				return;
			}
		}
		event.target.insertStringAtCursor(ch);
		event.preventDefault();

	}
	document.onkeypress = function(event) {
	
	if(window.kblayout=="en")return;
	var o=event.target;
	var str="";
	
	//if key is not a letter, return;
	if((event.keyCode!=39) && (event.keyCode<65 || event.keyCode>122))
	{
		window.prevchar="";
		return;
	}
	
	if(o.tagName=="INPUT" || o.tagName=="TEXTAREA" || o.tagName=="DIV")
	{
		var o=event.target;
		var k=String.fromCharCode(event.keyCode);
		var ch = window.rp[k] ? window.rp[k] : k;
	
		if(window.prevchar)
		{
			var prev=window.prevchar;
			if(window.rp[prev+ch])
			{
				ch=window.rp[prev+ch];
				window.prevchar="";
				document.execCommand("delete", true, 1);
			}
			else
			{
				if(ch=="й" || ch=="Й" || ch=="х" || ch=="Х" ||
					ch=="ш" || ch=="Ш" || ch=="ь" || ch=="Ь" ||
					ch=="г" || ch=="Г" || ch=="у" || ch=="У" || ch=="я" || ch=="Я")
				{
					window.prevchar=ch;
					//ch=prev;
				}
				else
				{
					window.prevchar="";
				}
			}
		}
		else
		{
		if(ch=="й" || ch=="Й" || ch=="х" || ch=="Х" ||
			ch=="ш" || ch=="Ш" || ch=="ь" || ch=="Ь" ||
			ch=="г" || ch=="Г" || ch=="у" || ch=="У" || ch=="я" || ch=="Я")
			{
				window.prevchar=ch;
			}
		}
		document.execCommand("insertText", true, ch);
		event.preventDefault();
	}
	}
	
	function cleanTimer() {
		timePress = 0;
	}
		document.write('<script type="text/javascript" onload="mojoLoaderLoaded();" src="/usr/palm/frameworks/mojoloader.js"><\/script>');
		//console.timeEnd('mojo.js:load');
	}

	load();

})();
